package org.hso.ecommerce.repos.booking;

import java.util.List;

import org.hso.ecommerce.entities.booking.Booking;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;
import org.springframework.stereotype.Repository;

@Repository
public interface BookingRepository extends JpaRepository<Booking, Long> {

    @Query("SELECT b FROM Booking b ORDER BY b.id DESC")
    List<Booking> allBookingsReverseChronologically();

    @Query("SELECT b FROM Booking b WHERE b.source.isMainAccount = 1 OR b.destination.isMainAccount = 1 ORDER BY b.id DESC")
    List<Booking> mainBookingsReverseChronologically();

    @Query("SELECT b FROM Booking b WHERE b.source.isVATAccount = 1 OR b.destination.isVATAccount = 1 ORDER BY b.id DESC")
    List<Booking> vatBookingsReverseChronologically();

    @Query("SELECT b FROM Booking b WHERE b.source.userAccount.id = :customerId OR b.destination.userAccount.id = :customerId ORDER BY b.id DESC")
    List<Booking> customerBookingsReverseChronologically(long customerId);

    @Query("SELECT b FROM Booking b WHERE b.source.supplierAccount.id = :supplierId OR b.destination.supplierAccount.id = :supplierId ORDER BY b.id DESC")
    List<Booking> supplierBookingsReverseChronologically(long supplierId);

}


